module bmp;

import std.stdio;
import std.File;

import std.bitmanip;	// swapEndian

// Bitmap Header - 14 bytes (NOT 16)
struct my_bmp_header{
	align(1):
	char[2] type;
	uint size;
	ushort res1;
	ushort res2;
	uint offset;
};

// 40 bytes
struct my_bmp_info{
	align(1):
	uint size;
	uint width;
	uint height;
	ushort planes;
	ushort depth;
	uint comp;
	uint isize;
	uint xppm;
	uint yppm;
	uint clrused;
	uint clrimp;
};


	

bool save_bmp(uint w,uint h,ubyte[] bmp_data,string outfn){
	// Make a BMP Header (Just the essentials so it opens!)
	my_bmp_header[1] bmp_header; 
	
	bmp_header[0].type[0]='B';
	bmp_header[0].type[1]='M';
	
	bmp_header[0].offset=54;
	
	my_bmp_info[1] bmp_info; 
	
	bmp_info[0].size=40;
	bmp_info[0].width=w;
	bmp_info[0].height=h;
	
	bmp_info[0].planes=1;
	bmp_info[0].depth=24;
		
	// string outfn=fn~".bmp";	// <-- Note squiggle used to join strings!

	outfn=outfn~".bmp";
	File outfile = File(outfn, "wb");   	
	writeln("Saving as ",outfn,"...");
	
	outfile.rawWrite(bmp_header);
	outfile.rawWrite(bmp_info);
	outfile.rawWrite(bmp_data);
	outfile.close();
	return true;
}	